Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.springframework.orm.jpa.support
Class OpenEntityManagerInViewFilter

    java.lang.Object
      org.springframework.web.filter.GenericFilterBean
          org.springframework.web.filter.OncePerRequestFilter
              org.springframework.orm.jpa.support.OpenEntityManagerInViewFilter

All Implemented Interfaces:
  javax.servlet.Filter, Aware, BeanNameAware, DisposableBean, InitializingBean, EnvironmentAware, ServletContextAware

    public class OpenEntityManagerInViewFilter

extends OncePerRequestFilter

Servlet 2.3 Filter that binds a JPA EntityManager to the thread for the entire processing of the request. Intended for the "Open EntityManager in View" pattern, i.e. to allow for lazy loading in web views despite the original transactions already being completed.

This filter makes JPA EntityManagers available via the current thread, which will be autodetected by transaction managers. It is suitable for service layer transactions via `JpaTransactionManager` or `JtaTransactionManager` as well as for non-transactional read-only execution.

Looks up the EntityManagerFactory in Spring's root web application context. Supports an "entityManagerFactoryBeanName" filter init-param in `web.xml`; the default bean name is "entityManagerFactory". As an alternative, the "persistenceUnitName" init-param allows for retrieval by logical unit name (as specified in `persistence.xml`).

Since:
  2.0
Author:
  Juergen Hoeller
See Also:
  `OpenEntityManagerInViewInterceptor`, `JpaInterceptor`, `JpaTransactionManager`, `JpaTemplate.execute(org.springframework.orm.jpa.JpaCallback)`, `SharedEntityManagerCreator`, `TransactionSynchronizationManager`

Field Summary
`static java.lang.String` | `DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME` Default EntityManagerFactory bean name: "entityManagerFactory".

Fields inherited from class org.springframework.web.filter.OncePerRequestFilter
`ALREADY_FILTERED_SUFFIX`

Fields inherited from class org.springframework.web.filter.GenericFilterBean
`logger`

Constructor Summary
`OpenEntityManagerInViewFilter()`

Method Summary
`protected javax.persistence.EntityManager` | `createEntityManager(javax.persistence.EntityManagerFactory emf)` Create a JPA EntityManager to be bound to a request.
`protected void` | `doFilterInternal(javax.servlet.http.HttpServletRequest request, javax.servlet.http.HttpServletResponse response, javax.servlet.FilterChain filterChain)` Same contract as for `doFilter`, but guaranteed to be just invoked once per request.
`protected java.lang.String` | `getEntityManagerFactoryBeanName()` Return the bean name of the EntityManagerFactory to fetch from Spring's root application context.
`protected java.lang.String` | `getPersistenceUnitName()` Return the name of the persistence unit to access the EntityManagerFactory for, if any.
`protected javax.persistence.EntityManagerFactory` | `lookupEntityManagerFactory()` Look up the EntityManagerFactory that this filter should use.
`protected javax.persistence.EntityManagerFactory` | `lookupEntityManagerFactory(javax.servlet.http.HttpServletRequest request)` Look up the EntityManagerFactory that this filter should use, taking the current HTTP request as argument.
`void` | `setEntityManagerFactoryBeanName(java.lang.String entityManagerFactoryBeanName)` Set the bean name of the EntityManagerFactory to fetch from Spring's root application context.
`void` | `setPersistenceUnitName(java.lang.String persistenceUnitName)` Set the name of the persistence unit to access the EntityManagerFactory for.

Methods inherited from class org.springframework.web.filter.OncePerRequestFilter
`doFilter, getAlreadyFilteredAttributeName, shouldNotFilter`

Methods inherited from class org.springframework.web.filter.GenericFilterBean
`addRequiredProperty, afterPropertiesSet, destroy, getFilterConfig, getFilterName, getServletContext, init, initBeanWrapper, initFilterBean, setBeanName, setEnvironment, setServletContext`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME

    public static final java.lang.String DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME

  Default EntityManagerFactory bean name: "entityManagerFactory". Only applies when no "persistenceUnitName" param has been specified.

  See Also:
    `setEntityManagerFactoryBeanName(java.lang.String)`, `setPersistenceUnitName(java.lang.String)`, Constant Field Values

Constructor Detail

### OpenEntityManagerInViewFilter

    public OpenEntityManagerInViewFilter()

Method Detail

### setEntityManagerFactoryBeanName

    public void setEntityManagerFactoryBeanName(java.lang.String entityManagerFactoryBeanName)

  Set the bean name of the EntityManagerFactory to fetch from Spring's root application context.

  Default is "entityManagerFactory". Note that this default only applies when no "persistenceUnitName" param has been specified.

  See Also:
    `setPersistenceUnitName(java.lang.String)`, `DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME`

### getEntityManagerFactoryBeanName

    protected java.lang.String getEntityManagerFactoryBeanName()

  Return the bean name of the EntityManagerFactory to fetch from Spring's root application context.

### setPersistenceUnitName

    public void setPersistenceUnitName(java.lang.String persistenceUnitName)

  Set the name of the persistence unit to access the EntityManagerFactory for.

  This is an alternative to specifying the EntityManagerFactory by bean name, resolving it by its persistence unit name instead. If no bean name and no persistence unit name have been specified, we'll check whether a bean exists for the default bean name "entityManagerFactory"; if not, a default EntityManagerFactory will be retrieved through finding a single unique bean of type EntityManagerFactory.

  See Also:
    `setEntityManagerFactoryBeanName(java.lang.String)`, `DEFAULT_ENTITY_MANAGER_FACTORY_BEAN_NAME`

### getPersistenceUnitName

    protected java.lang.String getPersistenceUnitName()

  Return the name of the persistence unit to access the EntityManagerFactory for, if any.

### doFilterInternal

    protected void doFilterInternal(javax.servlet.http.HttpServletRequest request,
                                    javax.servlet.http.HttpServletResponse response,
                                    javax.servlet.FilterChain filterChain)
                             throws javax.servlet.ServletException,
                                    java.io.IOException

  Description copied from class: `OncePerRequestFilter`
  Same contract as for `doFilter`, but guaranteed to be just invoked once per request. Provides HttpServletRequest and HttpServletResponse arguments instead of the default ServletRequest and ServletResponse ones.

  Specified by:
    `doFilterInternal` in class `OncePerRequestFilter`
  Throws:
    `javax.servlet.ServletException`
    `java.io.IOException`

### lookupEntityManagerFactory

    protected javax.persistence.EntityManagerFactory lookupEntityManagerFactory(javax.servlet.http.HttpServletRequest request)

  Look up the EntityManagerFactory that this filter should use, taking the current HTTP request as argument.

  The default implementation delegates to the `lookupEntityManagerFactory` without arguments, caching the EntityManagerFactory reference once obtained.

  Returns:
    the EntityManagerFactory to use
  See Also:
    `lookupEntityManagerFactory()`

### lookupEntityManagerFactory

    protected javax.persistence.EntityManagerFactory lookupEntityManagerFactory()

  Look up the EntityManagerFactory that this filter should use.

  The default implementation looks for a bean with the specified name in Spring's root application context.

  Returns:
    the EntityManagerFactory to use
  See Also:
    `getEntityManagerFactoryBeanName()`

### createEntityManager

    protected javax.persistence.EntityManager createEntityManager(javax.persistence.EntityManagerFactory emf)

  Create a JPA EntityManager to be bound to a request.

  Can be overridden in subclasses.

  Parameters:
    `emf` - the EntityManagerFactory to use
  See Also:
    `EntityManagerFactory.createEntityManager()`

Overview | Package | Class | Tree | Deprecated | Index | Help
| Spring Framework
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD